package org.mindtask.efs.boxnet;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class Activator implements BundleActivator {

	public static final String PLUGIN_ID = "org.mindtask.efs.boxnet";

	private static BundleContext context;

	static BundleContext getContext() {
		return context;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext bundleContext) throws Exception {
		Activator.context = bundleContext;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext bundleContext) throws Exception {
		Activator.context = null;
	}

	public static IStatus newStatus(int severity, String message, Throwable t) {
		String statusMessage = message;
		if (message == null || message.trim().length() == 0) {
			if (t == null) {
				throw new IllegalArgumentException();
			}
			else if (t.getMessage() == null) {
				statusMessage = t.toString();
			}
			else {
				statusMessage = t.getMessage();
			}
		}

		return new Status(severity, PLUGIN_ID, IStatus.OK, statusMessage, t);
	}

	public static IStatus newStatus(int severity, String message) {
		String statusMessage = message;
		return new Status(severity, PLUGIN_ID, statusMessage);
	}
}
