package org.mindtask.efs.boxnet;

import org.eclipse.core.filesystem.IFileInfo;
import org.eclipse.core.filesystem.provider.FileInfo;

import cn.com.believer.songyuanframework.openapi.storage.box.objects.BoxAbstractFile;

/**
 * This class should be used by box.net file system providers in their implementation
 * of API methods that return {@link IFileInfo} objects.
 * 
 * @author tanxu
 * @date Jan 22, 2012
 * @since 1.0
 * @noextend This class is not intended to be subclassed by clients.
 */
public class BoxFileInfo extends FileInfo {

	private BoxAbstractFile boxFile;

	public BoxFileInfo(BoxAbstractFile boxFile) {
		this.boxFile = boxFile;
		setExists(true);	// exists by default
	}

	@Override
	public boolean isDirectory() {
		return boxFile.isFolder();
	}

	@Override
	public long getLastModified() {
		return boxFile.getUpdated();
	}

	@Override
	public long getLength() {
		return boxFile.getSize();
	}

	@Override
	public String getName() {
		return boxFile.getName();
	}

	@Override
	public void setDirectory(boolean value) {
		throw new UnsupportedOperationException();
	}

}
