package org.mindtask.efs.boxnet;

/**
 * Store the user authentication information
 * 
 * @author tanxu
 * @date Jan 22, 2012
 * @since 1.0
 */
public class UserInfo {

	private String name;
	private String authToken;

	/**
	 * @param name
	 * @param authToken
	 */
	public UserInfo(String name, String authToken) {
		super();
		this.name = name;
		this.authToken = authToken;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the authToken
	 */
	public String getAuthToken() {
		return authToken;
	}

	/**
	 * @param authToken the authToken to set
	 */
	public void setAuthToken(String authToken) {
		this.authToken = authToken;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((authToken == null) ? 0 : authToken.hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UserInfo other = (UserInfo) obj;
		if (authToken == null) {
			if (other.authToken != null)
				return false;
		}
		else if (!authToken.equals(other.authToken))
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		}
		else if (!name.equals(other.name))
			return false;
		return true;
	}

}
